#include "framebuffer.h"

FrameBuffer::FrameBuffer(int u0, int v0, int _w, int _h) 
: Fl_Gl_Window(u0, v0, _w, _h, 0), w(_w), h(_h) {

  pix = new unsigned int[w*h];

}

void FrameBuffer::Set(unsigned int color) {

  for (int i = 0; i < w*h; i++) {
    pix[i] = color;
  }

}

void FrameBuffer::SetGuarded(int u, int v, unsigned int color) {

  if (u < 0 || u > w-1 || v < 0 || v > h-1)
    return;
  Set(u, v, color);

}

void FrameBuffer::Set(int u, int v, unsigned int color) {

  pix[(h-1-v)*w+u] = color;

}

void FrameBuffer::draw() {

  glDrawPixels(w, h, GL_RGBA, GL_UNSIGNED_BYTE, pix);

}

void FrameBuffer::DrawDiagonalCross(
  int u, int v, unsigned int color, int sizePix) {

  for (int i = 0; i < sizePix; i++) {
    SetGuarded(u-sizePix/2+i, v-sizePix/2+i, color);
    SetGuarded(u+sizePix/2-i, v-sizePix/2+i, color);
  }

}

void FrameBuffer::SetGrid(int checkerSize, unsigned int colors[2]) {

  for (int v = 0; v < h; v++) {
    for (int u = 0; u < w; u++) {
      Set(u, v, colors[(u/checkerSize+v/checkerSize)%2]);
    }
  }

}
