
#include "v3.h"

#include <iostream>

using namespace std;

V3::V3(float _x, float _y, float _z) : x(_x), y(_y), z(_z) {}

V3 V3::operator+(V3 op2) {

  V3 ret;
  ret.x = x+op2.x;
  ret.y = y+op2.y;
  ret.z = z+op2.z;
  return ret;

}

V3 V3::operator-(V3 op2) {

  V3 ret;
  ret.x = x-op2.x;
  ret.y = y-op2.y;
  ret.z = z-op2.z;
  return ret;

}

V3 V3::operator^(V3 op2) {

  V3 ret;
  ret.x = y*op2.z - z*op2.y;
  ret.y = z*op2.x - x*op2.z;
  ret.z = x*op2.y - y*op2.x;

  return ret;

}

float V3::operator*(V3 op2) {

  return (x*op2.x+y*op2.y+z*op2.z);

}

ostream& operator<<(ostream &ostr, V3 v) {

  return ostr << v.x << " " << v.y << " " << v.z;

}

float& V3::operator[](int i) {

  switch (i) {
    case 0: return x;
    case 1: return y;
    case 2: return z;
    default:
      cerr << "INTERNAL ERROR: bad index" << endl;
      return x;
  }

}

V3 V3::operator*(float sc) {

  V3 ret;
  ret.x = x*sc;
  ret.y = y*sc;
  ret.z = z*sc;
  return ret;

}

V3 V3::operator/(float sc) {

  V3 ret;
  ret.x = x/sc;
  ret.y = y/sc;
  ret.z = z/sc;
  return ret;

}

unsigned int V3::UIntColor() {

  unsigned int ret = 0xFF000000;
  ret += (unsigned int)(255.0f*x);
  ret += 256*(unsigned int)(255.0f*y);
  ret += 256*256*(unsigned int)(255.0f*z);
  return ret;

}
